/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.100 Revision 1.260
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.100 2005/02/12 22:32:12 eradicator Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.260 2011/08/29 01:28:10 vapier Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Copyright 2005 Gentoo Linux 9# Maintainer: kernel-misc@gentoo.org
10# 10#
11# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
12 12
13# added functionality: 13# added functionality:
14# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
22# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
27# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
28# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
29# the patchset version for 31# the patchset version for
30# and not use it as a true package revision 32# and not use it as a true package revision
31# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
32# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
33# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
34# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
35# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
36 39#
40# K_DEFCONFIG - Allow specifying a different defconfig target.
41# If length zero, defaults to "defconfig".
42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43# combination of "base" and "extras"
44# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45# A value of "5" would apply genpatches-2.6.12-5 to
46# my-sources-2.6.12.ebuild
47# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49# code. If empty, will be set to "1" if deblobbing is
50# possible. Test ONLY for "1".
51# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52# If false, either optional deblobbing will be available
53# or the license will note the inclusion of freedist
54# code.
55# K_LONGTERM - If set, the eclass will search for the kernel source
56# in the long term directories on the upstream servers
57# as the location has been changed by upstream
37# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 58# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
38# can be supported by the headers ebuild 59# can be supported by the headers ebuild
39 60
40# UNIPATCH_LIST - space delimetered list of patches to be applied to the 61# UNIPATCH_LIST - space delimetered list of patches to be applied to the
41# kernel 62# kernel
46# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 67# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
47# the doc dir 68# the doc dir
48# UNIPATCH_STRICTORDER - if this is set places patches into directories of 69# UNIPATCH_STRICTORDER - if this is set places patches into directories of
49# order, so they are applied in the order passed 70# order, so they are applied in the order passed
50 71
51inherit toolchain-funcs versionator multilib 72inherit eutils toolchain-funcs versionator multilib
52ECLASS="kernel-2" 73EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
53INHERITED="$INHERITED $ECLASS" 74
54EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 75# Added by Daniel Ostrow <dostrow@gentoo.org>
55 pkg_preinst pkg_postinst 76# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
77# I will remove it when I come up with something more reasonable.
78[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
56 79
57export CTARGET=${CTARGET:-${CHOST}} 80export CTARGET=${CTARGET:-${CHOST}}
58if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 81if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
59 export CTARGET=${CATEGORY/cross-} 82 export CTARGET=${CATEGORY/cross-}
60fi 83fi
61 84
62HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 85HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
86[[ -z ${LICENSE} ]] && \
63LICENSE="GPL-2" 87 LICENSE="GPL-2"
88
89# This is the latest KV_PATCH of the deblob tool available from the
90# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
91# for ALL kernel-2 consumer packages where deblob is available.
92[[ -z ${DEBLOB_MAX_VERSION} ]] && DEBLOB_MAX_VERSION=38
93
94# No need to run scanelf/strip on kernel sources/headers (bug #134453).
95RESTRICT="binchecks strip"
64 96
65# set LINUX_HOSTCFLAGS if not already set 97# set LINUX_HOSTCFLAGS if not already set
66[ -z "$LINUX_HOSTCFLAGS" ] && \ 98[[ -z ${LINUX_HOSTCFLAGS} ]] && \
67 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 99 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"
100
101# debugging functions
102#==============================================================
103# this function exists only to help debug kernel-2.eclass
104# if you are adding new functionality in, put a call to it
105# at the start of src_unpack, or during SRC_URI/dep generation.
106debug-print-kernel2-variables() {
107 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
108 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
109 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
110 debug-print "${v}: ${!v}"
111 done
112}
68 113
69#Eclass functions only from here onwards ... 114#Eclass functions only from here onwards ...
70#============================================================== 115#==============================================================
116handle_genpatches() {
117 local tarball
118 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
119
120 debug-print "Inside handle_genpatches"
121 local oldifs=${IFS}
122 export IFS="."
123 local OKV_ARRAY=( $OKV )
124 export IFS=${oldifs}
125
126 # for > 3.0 kernels, handle genpatches tarball name
127 # genpatches for 3.0 and 3.0.1 might be named
128 # genpatches-3.0-1.base.tar.bz2 and genpatches-3.0-2.base.tar.bz2
129 # respectively. Handle this.
130
131 for i in ${K_WANT_GENPATCHES} ; do
132 if [[ ${KV_MAJOR} -ge 3 ]]; then
133 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
134 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.bz2"
135 else
136 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.bz2"
137 fi
138 else
139 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2"
140 fi
141 debug-print "genpatches tarball: $tarball"
142 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
143 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
144 done
145}
146
147detect_version() {
148 # this function will detect and set
149 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
150 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
151 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
152
153 if [[ -n ${KV_FULL} ]]; then
154 # we will set this for backwards compatibility.
155 KV=${KV_FULL}
156
157 # we know KV_FULL so lets stop here. but not without resetting S
158 S=${WORKDIR}/linux-${KV_FULL}
159 return
160 fi
161
162 # CKV is used as a comparison kernel version, which is used when
163 # PV doesnt reflect the genuine kernel version.
164 # this gets set to the portage style versioning. ie:
165 # CKV=2.6.11_rc4
166 CKV=${CKV:-${PV}}
167 OKV=${OKV:-${CKV}}
168 OKV=${OKV/_beta/-test}
169 OKV=${OKV/_rc/-rc}
170 OKV=${OKV/-r*}
171 OKV=${OKV/_p*}
172
173 KV_MAJOR=$(get_version_component_range 1 ${OKV})
174 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
175 local oldifs=${IFS}
176 export IFS="."
177 local OKV_ARRAY=( $OKV )
178 export IFS=${oldifs}
179
180 # if KV_MAJOR >= 3, then we have no more KV_MINOR
181 #if [[ ${KV_MAJOR} -lt 3 ]]; then
182 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
183 KV_MINOR=$(get_version_component_range 2 ${OKV})
184 KV_PATCH=$(get_version_component_range 3 ${OKV})
185 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
186 KV_EXTRA=$(get_version_component_range 4- ${OKV})
187 KV_EXTRA=${KV_EXTRA/[-_]*}
188 else
189 KV_PATCH=$(get_version_component_range 3- ${OKV})
190 fi
191 else
192 KV_PATCH=$(get_version_component_range 2 ${OKV})
193 KV_EXTRA=$(get_version_component_range 3- ${OKV})
194 KV_EXTRA=${KV_EXTRA/[-_]*}
195 fi
196
197 debug-print "KV_EXTRA is ${KV_EXTRA}"
198
199 KV_PATCH=${KV_PATCH/[-_]*}
200
201 local v n=0 missing
202 #if [[ ${KV_MAJOR} -lt 3 ]]; then
203 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
204 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
205 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
206 done
207 else
208 for v in CKV OKV KV_{MAJOR,PATCH} ; do
209 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
210 done
211 fi
212
213 [[ $n -eq 1 ]] && \
214 eerror "Missing variables: ${missing}" && \
215 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
216 unset v n missing
217
218# if [[ ${KV_MAJOR} -ge 3 ]]; then
219 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
220 KV_PATCH_ARR=(${KV_PATCH//\./ })
221
222 # at this point 080811, Linus is putting 3.1 kernels in 3.0 directory
223 # revisit when 3.1 is released
224 if [[ ${KV_PATCH} -gt 0 ]]; then
225 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
226 else
227 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_PATCH_ARR}"
228 fi
229 # KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_PATCH_ARR}"
230 [[ -n "${K_LONGTERM}" ]] &&
231 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
232 else
233 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
234 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
235 [[ -n "${K_LONGTERM}" ]] &&
236 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
237 fi
238
239 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
240
241 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
242 # handle non genpatch using sources correctly
243 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
244 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.bz2"
245 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
246 fi
247 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.bz2"
248 else
249 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
250 fi
251
252 RELEASE=${CKV/${OKV}}
253 RELEASE=${RELEASE/_beta}
254 RELEASE=${RELEASE/_rc/-rc}
255 RELEASE=${RELEASE/_pre/-pre}
256 # We cannot trivally call kernel_is here, because it calls us to detect the
257 # version
258 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
259 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
260 RELEASETYPE=${RELEASE//[0-9]}
261
262 # Now we know that RELEASE is the -rc/-git
263 # and RELEASETYPE is the same but with its numerics stripped
264 # we can work on better sorting EXTRAVERSION.
265 # first of all, we add the release
266 EXTRAVERSION="${RELEASE}"
267 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
268 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
269
270 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
271 if [[ -n "${K_NOUSEPR}" ]]; then
272 # Don't add anything based on PR to EXTRAVERSION
273 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
274 elif [[ -n ${K_PREPATCHED} ]]; then
275 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
276 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
277 elif [[ "${ETYPE}" = "sources" ]]; then
278 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
279 # For some sources we want to use the PV in the extra version
280 # This is because upstream releases with a completely different
281 # versioning scheme.
282 case ${PN/-*} in
283 wolk) K_USEPV=1;;
284 vserver) K_USEPV=1;;
285 esac
286
287 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
288 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
289 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
290 fi
291 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
292
293 # The only messing around which should actually effect this is for KV_EXTRA
294 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
295 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
296
297 if [[ -n ${KV_EXTRA} ]]; then
298 if [[ -n ${KV_MINOR} ]]; then
299 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
300 else
301 OKV="${KV_MAJOR}.${KV_PATCH}"
302 fi
303 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.bz2
304 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
305 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2"
306 fi
307
308 # We need to set this using OKV, but we need to set it before we do any
309 # messing around with OKV based on RELEASETYPE
310 KV_FULL=${OKV}${EXTRAVERSION}
311
312 # we will set this for backwards compatibility.
313 S=${WORKDIR}/linux-${KV_FULL}
314 KV=${KV_FULL}
315
316 # -rc-git pulls can be achieved by specifying CKV
317 # for example:
318 # CKV="2.6.11_rc3_pre2"
319 # will pull:
320 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2
321
322 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
323
324 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
325 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
326 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.bz2
327 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
328 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
329 fi
330
331 if [[ ${RELEASETYPE} == -git ]]; then
332 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.bz2
333 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
334 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
335 fi
336
337 if [[ ${RELEASETYPE} == -rc-git ]]; then
338 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
339 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
340 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2
341 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
342
343 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
344 fi
345 else
346 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
347 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
348 OKV="2.6.39"
349 else
350 KV_PATCH_ARR=(${KV_PATCH//\./ })
351 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
352 fi
353 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.bz2
354 ${KERNEL_BASE_URI}/testing/linux-${OKV}.tar.bz2"
355 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
356 fi
357
358 if [[ ${RELEASETYPE} == -git ]]; then
359 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.bz2
360 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
361 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
362 fi
363
364 if [[ ${RELEASETYPE} == -rc-git ]]; then
365 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
366 OKV="2.6.39"
367 else
368 KV_PATCH_ARR=(${KV_PATCH//\./ })
369 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
370 fi
371 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.bz2
372 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.bz2
373 ${KERNEL_BASE_URI}/linux-${OKV}.tar.bz2"
374
375 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.bz2"
376 fi
377
378
379 fi
380
381
382 debug-print-kernel2-variables
383
384 handle_genpatches
385}
386
71kernel_is() { 387kernel_is() {
72 [[ -z ${OKV} ]] && return 1 388 # ALL of these should be set before we can safely continue this function.
389 # some of the sources have in the past had only one set.
390 local v n=0
391 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
392 [[ $n -eq 1 ]] && detect_version
393 unset v n
394
395 # Now we can continue
73 local operator test value x=0 y=0 z=0 396 local operator test value x=0 y=0 z=0
74 397
75 case ${1} in 398 case ${1} in
76 lt) operator="-lt"; shift;; 399 lt) operator="-lt"; shift;;
77 gt) operator="-gt"; shift;; 400 gt) operator="-gt"; shift;;
83 406
84 for x in ${@}; do 407 for x in ${@}; do
85 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done 408 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
86 value="${value}${x}" 409 value="${value}${x}"
87 z=$((${z} + 1)) 410 z=$((${z} + 1))
88 411
89 case ${z} in 412 case ${z} in
90 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done; 413 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
91 test="${test}${KV_MAJOR}";; 414 test="${test}${KV_MAJOR}";;
92 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done; 415 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
93 test="${test}${KV_MINOR}";; 416 test="${test}${KV_MINOR}";;
98 done 421 done
99 422
100 [ ${test} ${operator} ${value} ] && return 0 || return 1 423 [ ${test} ${operator} ${value} ] && return 0 || return 1
101} 424}
102 425
103
104kernel_is_2_4() { 426kernel_is_2_4() {
105 kernel_is 2 4 427 kernel_is 2 4
106} 428}
107 429
108kernel_is_2_6() { 430kernel_is_2_6() {
109 kernel_is 2 6 || kernel_is 2 5 431 kernel_is 2 6 || kernel_is 2 5
110}
111
112kernel_header_destdir() {
113 [[ ${CTARGET} == ${CHOST} ]] \
114 && echo /usr/include \
115 || echo /usr/${CTARGET}/include
116} 432}
117 433
118# Capture the sources type and set DEPENDs 434# Capture the sources type and set DEPENDs
119if [[ ${ETYPE} == sources ]]; then 435if [[ ${ETYPE} == sources ]]; then
120 DEPEND="!build? ( sys-apps/sed 436 DEPEND="!build? ( sys-apps/sed
121 >=sys-devel/binutils-2.11.90.0.31 ) 437 >=sys-devel/binutils-2.11.90.0.31 )"
122 doc? ( app-text/docbook-sgml-utils )"
123 RDEPEND="${DEPEND}
124 !build? ( >=sys-libs/ncurses-5.2 438 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
125 sys-devel/make )" 439 sys-devel/make )"
440 PDEPEND="!build? ( virtual/dev-manager )"
126 441
127 PROVIDE="virtual/linux-sources"
128 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa"
129 SLOT="${PVR}" 442 SLOT="${PVR}"
130 DESCRIPTION="Sources for the Linux kernel" 443 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR:-$KV_PATCH} linux kernel"
131 IUSE="${IUSE} symlink build doc" 444 IUSE="symlink build"
445
446 # Bug #266157, deblob for libre support
447 if [[ -z ${K_PREDEBLOBBED} ]] ; then
448 # Bug #359865, force a call to detect_version if needed
449 kernel_is ge 2 6 27 && \
450 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
451 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
452 K_DEBLOB_AVAILABLE=1
453 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
454 IUSE="${IUSE} deblob"
455 # Reflect that kernels contain firmware blobs unless otherwise
456 # stripped
457 LICENSE="${LICENSE} !deblob? ( freedist )"
458
459 if [[ -n KV_MINOR ]]; then
460 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
461 else
462 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
463 fi
464
465 if [[ ${KV_MAJOR} -ge 3 ]]; then
466 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
467 fi
468
469 DEBLOB_A="deblob-${DEBLOB_PV}"
470 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
471 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
472 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
473 if ! has "${EAPI:-0}" 0 1 ; then
474 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
475 else
476 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
477 fi
478 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
479 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
480
481 KERNEL_URI="${KERNEL_URI}
482 deblob? (
483 ${DEBLOB_URI}
484 ${DEBLOB_CHECK_URI}
485 )"
486 else
487 # We have no way to deblob older kernels, so just mark them as
488 # tainted with non-libre materials.
489 LICENSE="${LICENSE} freedist"
490 fi
491 fi
492
132elif [[ ${ETYPE} == headers ]]; then 493elif [[ ${ETYPE} == headers ]]; then
133 DESCRIPTION="Linux system headers" 494 DESCRIPTION="Linux system headers"
134 IUSE="${IUSE}" 495
135 496 # Since we should NOT honour KBUILD_OUTPUT in headers
497 # lets unset it here.
498 unset KBUILD_OUTPUT
499
136 if [[ ${CTARGET} = ${CHOST} ]]; then 500 if [[ ${CTARGET} = ${CHOST} ]]; then
137 DEPEND="!virtual/os-headers"
138 PROVIDE="virtual/kernel virtual/os-headers"
139 SLOT="0" 501 SLOT="0"
140 else 502 else
141 SLOT="${CTARGET}" 503 SLOT="${CTARGET}"
142 fi 504 fi
143else 505else
144 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 506 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
145 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 507 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
146fi 508fi
147 509
510# Cross-compile support functions
511#==============================================================
512kernel_header_destdir() {
513 [[ ${CTARGET} == ${CHOST} ]] \
514 && echo /usr/include \
515 || echo /usr/${CTARGET}/usr/include
516}
517
518cross_pre_c_headers() {
519 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
520}
521
522env_setup_xmakeopts() {
523 # Kernel ARCH != portage ARCH
524 export KARCH=$(tc-arch-kernel)
525
526 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
527 # variables properly or bad things happen !
528 xmakeopts="ARCH=${KARCH}"
529 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
530 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
531 elif type -p ${CHOST}-ar > /dev/null ; then
532 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
533 fi
534 export xmakeopts
535}
536
148# Unpack functions 537# Unpack functions
149#============================================================== 538#==============================================================
150unpack_2_4() { 539unpack_2_4() {
151 cd ${S}
152 # this file is required for other things to build properly, 540 # this file is required for other things to build properly,
153 # so we autogenerate it 541 # so we autogenerate it
154 make mrproper || die "make mrproper died" 542 make -s mrproper ${xmakeopts} || die "make mrproper failed"
543 make -s symlinks ${xmakeopts} || die "make symlinks failed"
155 make include/linux/version.h || die "make include/linux/version.h failed" 544 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
156 echo ">>> version.h compiled successfully." 545 echo ">>> version.h compiled successfully."
157} 546}
158 547
548unpack_2_6() {
549 # this file is required for other things to build properly, so we
550 # autogenerate it ... generate a .config to keep version.h build from
551 # spitting out an annoying warning
552 make -s mrproper ${xmakeopts} 2>/dev/null \
553 || die "make mrproper failed"
554
555 # quick fix for bug #132152 which triggers when it cannot include linux
556 # headers (ie, we have not installed it yet)
557 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
558 touch .config
559 eerror "make defconfig failed."
560 eerror "assuming you dont have any headers installed yet and continuing"
561 epause 5
562 fi
563
564 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
565 || die "make include/linux/version.h failed"
566 rm -f .config >/dev/null
567}
568
159universal_unpack() { 569universal_unpack() {
570 debug-print "Inside universal_unpack"
571
572 local oldifs=${IFS}
573 export IFS="."
574 local OKV_ARRAY=( $OKV )
575 export IFS=${oldifs}
576
160 cd ${WORKDIR} 577 cd "${WORKDIR}"
578 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
579 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.bz2
580 else
161 unpack linux-${OKV}.tar.bz2 581 unpack linux-${OKV}.tar.bz2
162 if [[ "${OKV}" != "${KV_FULL}" ]]; then 582 fi
583
584 if [[ -d "linux" ]]; then
585 debug-print "Moving linux to linux-${KV_FULL}"
163 mv linux-${OKV} linux-${KV_FULL} \ 586 mv linux linux-${KV_FULL} \
164 || die "Unable to move source tree to ${KV_FULL}." 587 || die "Unable to move source tree to ${KV_FULL}."
588 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
589 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
590 [[ "${ETYPE}" = "sources" ]]; then
591 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
592 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
593 || die "Unable to move source tree to ${KV_FULL}."
594 else
595 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
596 mv linux-${OKV} linux-${KV_FULL} \
597 || die "Unable to move source tree to ${KV_FULL}."
165 fi 598 fi
599 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
600 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
601 || die "Unable to move source tree to ${KV_FULL}."
602 fi
166 cd ${S} 603 cd "${S}"
167
168 # change incorrect install path
169 sed -ie 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
170 604
171 # remove all backup files 605 # remove all backup files
172 find . -iname "*~" -exec rm {} \; 2> /dev/null 606 find . -iname "*~" -exec rm {} \; 2> /dev/null
173 607
174 if [[ -d ${S}/Documentation/DocBook ]]; then
175 cd ${S}/Documentation/DocBook
176 sed -ie "s:db2:docbook2:g" Makefile
177 cd ${OLDPWD}
178 fi
179
180 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox 608 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
181 use ppc && \ 609 # only do this for kernel < 2.6.27 since this file does not exist in later
610 # kernels
611 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
612 then
613 sed -i \
182 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \ 614 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
183 ${S}/arch/ppc/Makefile 615 "${S}"/arch/ppc/Makefile
616 else
617 sed -i \
618 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
619 "${S}"/arch/powerpc/Makefile
620 fi
184} 621}
185 622
186unpack_set_extraversion() { 623unpack_set_extraversion() {
187 cd ${S} 624 cd "${S}"
188 sed -ie "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 625 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
189 cd ${OLDPWD} 626 cd "${OLDPWD}"
627}
628
629# Should be done after patches have been applied
630# Otherwise patches that modify the same area of Makefile will fail
631unpack_fix_install_path() {
632 cd "${S}"
633 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
190} 634}
191 635
192# Compile Functions 636# Compile Functions
193#============================================================== 637#==============================================================
194compile_headers() { 638compile_headers() {
639 env_setup_xmakeopts
640
195 # if we couldnt obtain HOSTCFLAGS from the Makefile, 641 # if we couldnt obtain HOSTCFLAGS from the Makefile,
196 # then set it to something sane 642 # then set it to something sane
197 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS ${S}/Makefile) 643 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
198 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 644 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
199
200 # Kernel ARCH != portage ARCH
201 local KARCH=$(tc-arch-kernel)
202
203 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
204 # variables properly or bad things happen !
205 local xmakeopts="ARCH=${KARCH}"
206 if [[ ${CTARGET} != ${CHOST} ]]; then
207 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
208 elif type -p ${CHOST}-ar; then
209 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
210 fi
211 645
212 if kernel_is 2 4; then 646 if kernel_is 2 4; then
213 yes "" | make oldconfig ${xmakeopts} 647 yes "" | make oldconfig ${xmakeopts}
214 echo ">>> make oldconfig complete" 648 echo ">>> make oldconfig complete"
215 use sparc && make dep ${xmakeopts} 649 make dep ${xmakeopts}
216 elif kernel_is 2 6; then 650 elif kernel_is 2 6; then
651 # 2.6.18 introduces headers_install which means we dont need any
652 # of this crap anymore :D
653 kernel_is ge 2 6 18 && return 0
654
217 # autoconf.h isnt generated unless it already exists. plus, we have 655 # autoconf.h isnt generated unless it already exists. plus, we have
218 # no guarantee that any headers are installed on the system... 656 # no guarantee that any headers are installed on the system...
219 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 657 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
220 || touch include/linux/autoconf.h 658 || touch include/linux/autoconf.h
659
660 # if K_DEFCONFIG isn't set, force to "defconfig"
661 # needed by mips
662 if [[ -z ${K_DEFCONFIG} ]]; then
663 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
664 case ${CTARGET} in
665 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
666 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
667 *) K_DEFCONFIG="defconfig";;
668 esac
669 else
670 K_DEFCONFIG="defconfig"
671 fi
672 fi
221 673
222 # if there arent any installed headers, then there also isnt an asm 674 # if there arent any installed headers, then there also isnt an asm
223 # symlink in /usr/include/, and make defconfig will fail, so we have 675 # symlink in /usr/include/, and make defconfig will fail, so we have
224 # to force an include path with $S. 676 # to force an include path with $S.
225 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 677 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
226 ln -sf asm-${KARCH} "${S}"/include/asm 678 ln -sf asm-${KARCH} "${S}"/include/asm
679 cross_pre_c_headers && return 0
680
681 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
682 if compile_headers_tweak_config ; then
227 make defconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 683 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
684 fi
228 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 685 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
229 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 686 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
230 die "die"
231 fi 687 fi
232} 688}
233 689
234compile_manpages() { 690compile_headers_tweak_config() {
235 einfo "Making manpages ..." 691 # some targets can be very very picky, so let's finesse the
236 env -u ARCH make mandocs 692 # .config based upon any info we may have
693 case ${CTARGET} in
694 sh*)
695 sed -i '/CONFIG_CPU_SH/d' .config
696 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
697 return 0;;
698 esac
699
700 # no changes, so lets do nothing
701 return 1
237} 702}
238 703
239# install functions 704# install functions
240#============================================================== 705#==============================================================
241install_universal() { 706install_universal() {
242 #fix silly permissions in tarball 707 #fix silly permissions in tarball
243 cd ${WORKDIR} 708 cd "${WORKDIR}"
244 chown -R root:root * 709 chown -R root:0 * >& /dev/null
245 chmod -R a+r-w+X,u+w * 710 chmod -R a+r-w+X,u+w *
246 cd ${OLDPWD} 711 cd ${OLDPWD}
247} 712}
248 713
249install_headers() { 714install_headers() {
250 local ddir=$(kernel_header_destdir) 715 local ddir=$(kernel_header_destdir)
251 716
252 cd ${S} 717 # 2.6.18 introduces headers_install which means we dont need any
718 # of this crap anymore :D
719 if kernel_is ge 2 6 18 ; then
720 env_setup_xmakeopts
721 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
722
723 # let other packages install some of these headers
724 rm -rf "${D}"/${ddir}/sound #alsa-headers
725 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
726 return 0
727 fi
728
729 # Do not use "linux/*" as that can cause problems with very long
730 # $S values where the cmdline to cp is too long
731 pushd "${S}" >/dev/null
253 dodir ${ddir}/linux 732 dodir ${ddir}/linux
254 cp -ax ${S}/include/linux/* ${D}/${ddir}/linux 733 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
255 rm -rf ${D}/${ddir}/linux/modules 734 rm -rf "${D}"/${ddir}/linux/modules
256 735
257 # Handle multilib headers
258 case $(tc-arch-kernel) in
259 sparc64)
260 dodir ${ddir}/asm-sparc
261 cp -ax ${S}/include/asm-sparc/* ${D}/${ddir}/asm-sparc
262
263 dodir ${ddir}/asm-sparc64
264 cp -ax ${S}/include/asm-sparc64/* ${D}/${ddir}/asm-sparc64
265
266 create_ml_includes ${ddir}/asm __sparc__:${ddir}/asm-sparc __sparc64__:${ddir}/asm-sparc64
267 ;;
268 x86_64)
269 dodir ${ddir}/asm-i386
270 cp -ax ${S}/include/asm-i386/* ${D}/${ddir}/asm-i386
271
272 dodir ${ddir}/asm-x86_64
273 cp -ax ${S}/include/asm-x86_64/* ${D}/${ddir}/asm-x86_64
274
275 create_ml_includes ${ddir}/asm __i386__:${ddir}/asm-i386 __x86_64__:${ddir}/asm-x86_64
276 ;;
277 *)
278 dodir ${ddir}/asm 736 dodir ${ddir}/asm
279 cp -ax ${S}/include/asm/* ${D}/${ddir}/asm 737 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
280 ;;
281 esac
282 738
283 if kernel_is 2 6; then 739 if kernel_is 2 6 ; then
284 dodir ${ddir}/asm-generic 740 dodir ${ddir}/asm-generic
285 cp -ax ${S}/include/asm-generic/* ${D}/${ddir}/asm-generic 741 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
286 fi 742 fi
287 743
288 cd ${OLDPWD} 744 # clean up
745 find "${D}" -name '*.orig' -exec rm -f {} \;
746
747 popd >/dev/null
289} 748}
290 749
291install_sources() { 750install_sources() {
292 local doc docs file 751 local file
293 752
294 cd ${S} 753 cd "${S}"
295 dodir /usr/src 754 dodir /usr/src
296 echo ">>> Copying sources ..." 755 echo ">>> Copying sources ..."
297 756
298 file="$(find ${WORKDIR} -iname "docs" -type d)" 757 file="$(find ${WORKDIR} -iname "docs" -type d)"
299 if [[ -n ${file} ]]; then 758 if [[ -n ${file} ]]; then
300 for file in $(find ${file} -type f); do 759 for file in $(find ${file} -type f); do
301 echo "${file//*docs\/}" >> ${S}/patches.txt 760 echo "${file//*docs\/}" >> "${S}"/patches.txt
302 echo "===================================================" >> ${S}/patches.txt 761 echo "===================================================" >> "${S}"/patches.txt
303 cat ${file} >> ${S}/patches.txt 762 cat ${file} >> "${S}"/patches.txt
304 echo "===================================================" >> ${S}/patches.txt 763 echo "===================================================" >> "${S}"/patches.txt
305 echo "" >> ${S}/patches.txt 764 echo "" >> "${S}"/patches.txt
306 done 765 done
307 fi 766 fi
308 767
309 if [[ ! -f ${S}/patches.txt ]]; then 768 if [[ ! -f ${S}/patches.txt ]]; then
310 # patches.txt is empty so lets use our ChangeLog 769 # patches.txt is empty so lets use our ChangeLog
311 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 770 [[ -f ${FILESDIR}/../ChangeLog ]] && \
312 echo "Please check the ebuild ChangeLog for more details." \ 771 echo "Please check the ebuild ChangeLog for more details." \
313 > ${S}/patches.txt 772 > "${S}"/patches.txt
314 fi 773 fi
315 774
316 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
317 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
318 use doc && ! use arm && ! use s390 && install_manpages
319 dodoc ${docs}
320
321 mv ${WORKDIR}/linux* ${D}/usr/src 775 mv ${WORKDIR}/linux* "${D}"/usr/src
322}
323
324install_manpages() {
325 sed -ie "s#/usr/local/man#${D}/usr/man#g" scripts/makeman
326 ebegin "Installing manpages"
327 env -u ARCH make installmandocs
328 eend $?
329 sed -ie "s#${D}/usr/man#/usr/local/man#g" scripts/makeman
330} 776}
331 777
332# pkg_preinst functions 778# pkg_preinst functions
333#============================================================== 779#==============================================================
334preinst_headers() { 780preinst_headers() {
339 785
340# pkg_postinst functions 786# pkg_postinst functions
341#============================================================== 787#==============================================================
342postinst_sources() { 788postinst_sources() {
343 local MAKELINK=0 789 local MAKELINK=0
344 790
345 # if we have USE=symlink, then force K_SYMLINK=1 791 # if we have USE=symlink, then force K_SYMLINK=1
346 use symlink && K_SYMLINK=1 792 use symlink && K_SYMLINK=1
347 793
794 # if we're using a deblobbed kernel, it's not supported
795 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
796 use deblob && \
797 K_SECURITY_UNSUPPORTED=deblob
798
348 # if we are to forcably symlink, delete it if it already exists first. 799 # if we are to forcably symlink, delete it if it already exists first.
349 if [[ -n ${K_SYMLINK} ]]; then 800 if [[ ${K_SYMLINK} > 0 ]]; then
350 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 801 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
351 MAKELINK=1 802 MAKELINK=1
352 fi 803 fi
353 804
354 # if the link doesnt exist, lets create it 805 # if the link doesnt exist, lets create it
355 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 806 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
356 807
357 if [[ ${MAKELINK} == 1 ]]; then 808 if [[ ${MAKELINK} == 1 ]]; then
358 cd ${ROOT}usr/src 809 cd "${ROOT}"usr/src
359 ln -sf linux-${KV_FULL} linux 810 ln -sf linux-${KV_FULL} linux
360 cd ${OLDPWD} 811 cd ${OLDPWD}
361 fi 812 fi
362 813
363 # Don't forget to make directory for sysfs 814 # Don't forget to make directory for sysfs
364 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir /sys 815 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
365 816
366 echo 817 echo
367 einfo "After installing a new kernel of any version, it is important" 818 elog "If you are upgrading from a previous kernel, you may be interested"
368 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y" 819 elog "in the following document:"
369 einfo "created (X.Y is the first 2 parts of your new kernel version)" 820 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
370 echo
371 einfo "For example, this kernel will require:"
372 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
373 echo 821 echo
374 822
375 # if K_EXTRAEINFO is set then lets display it now 823 # if K_EXTRAEINFO is set then lets display it now
376 if [[ -n ${K_EXTRAEINFO} ]]; then 824 if [[ -n ${K_EXTRAEINFO} ]]; then
377 echo ${K_EXTRAEINFO} | fmt | 825 echo ${K_EXTRAEINFO} | fmt |
378 while read -s ELINE; do einfo "${ELINE}"; done 826 while read -s ELINE; do einfo "${ELINE}"; done
379 fi 827 fi
380 828
829 # if K_EXTRAELOG is set then lets display it now
830 if [[ -n ${K_EXTRAELOG} ]]; then
831 echo ${K_EXTRAELOG} | fmt |
832 while read -s ELINE; do elog "${ELINE}"; done
833 fi
834
381 # if K_EXTRAEWARN is set then lets display it now 835 # if K_EXTRAEWARN is set then lets display it now
382 if [[ -n ${K_EXTRAEWARN} ]]; then 836 if [[ -n ${K_EXTRAEWARN} ]]; then
383 echo ${K_EXTRAEWARN} | fmt | 837 echo ${K_EXTRAEWARN} | fmt |
384 while read -s ELINE; do ewarn "${ELINE}"; done 838 while read -s ELINE; do ewarn "${ELINE}"; done
385 fi 839 fi
386}
387 840
388postinst_headers() { 841 # optionally display security unsupported message
389 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 842 # Start with why
390 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 843 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
391 einfo "emerge glibc" 844 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
392 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 845 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
393 einfo "headers." 846 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
847 fi
848 # And now the general message.
849 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
850 ewarn "This means that it is likely to be vulnerable to recent security issues."
851 ewarn "For specific information on why this kernel is unsupported, please read:"
852 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
853 fi
854
855 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
856 KV_MAJOR=$(get_version_component_range 1 ${OKV})
857 KV_MINOR=$(get_version_component_range 2 ${OKV})
858 KV_PATCH=$(get_version_component_range 3 ${OKV})
859 if [[ "$(tc-arch)" = "sparc" ]]; then
860 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
861 then
862 echo
863 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
864 elog "you now need to do"
865 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
866 elog "instead of just"
867 elog " make"
868 elog "to compile the kernel. For more information please browse to"
869 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
870 echo
871 fi
872 fi
394} 873}
395 874
396# pkg_setup functions 875# pkg_setup functions
397#============================================================== 876#==============================================================
398setup_headers() { 877setup_headers() {
401 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes" 880 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
402 done 881 done
403 882
404 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then 883 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
405 echo 884 echo
406 eerror "This version of ${PN} does not support ${ARCH}." 885 eerror "This version of ${PN} does not support $(tc-arch)."
407 eerror "Please merge the appropriate sources, in most cases" 886 eerror "Please merge the appropriate sources, in most cases"
408 eerror "(but not all) this will be called ${ARCH}-headers." 887 eerror "(but not all) this will be called $(tc-arch)-headers."
409 die "Package unsupported for ${ARCH}" 888 die "Package unsupported for $(tc-arch)"
410 fi 889 fi
411} 890}
412 891
413# unipatch 892# unipatch
414#============================================================== 893#==============================================================
415unipatch() { 894unipatch() {
416 local i x extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE 895 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
417 local STRICT_COUNT PATCH_LEVEL myLC_ALL 896 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
418 897
419 # set to a standard locale to ensure sorts are ordered properly. 898 # set to a standard locale to ensure sorts are ordered properly.
420 myLC_ALL="${LC_ALL}" 899 myLC_ALL="${LC_ALL}"
900 myLANG="${LANG}"
421 LC_ALL="C" 901 LC_ALL="C"
902 LANG=""
422 903
423 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 904 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
424 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 905 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
425 906
426 # We're gonna need it when doing patches with a predefined patchlevel 907 # We're gonna need it when doing patches with a predefined patchlevel
427 shopt -s extglob 908 eshopts_push -s extglob
428 909
429 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 910 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
430 # usage can be either via an env var or by params 911 # usage can be either via an env var or by params
431 # although due to the nature we pass this within this eclass 912 # although due to the nature we pass this within this eclass
432 # it shall be by param only. 913 # it shall be by param only.
433 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 914 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
434 UNIPATCH_LIST="${@}" 915 UNIPATCH_LIST="${@}"
435 916
436 #unpack any passed tarballs 917 #unpack any passed tarballs
437 for i in ${UNIPATCH_LIST}; do 918 for i in ${UNIPATCH_LIST}; do
438 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 919 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
439 extention=${i/*./}
440 extention=${extention/:*/}
441 case ${extention} in
442 tbz2) PIPE_CMD="tar -xvjf";;
443 bz2) PIPE_CMD="tar -xvjf";;
444 tgz) PIPE_CMD="tar -xvzf";;
445 gz) PIPE_CMD="tar -xvzf";;
446 *) eerror "Unrecognized tarball compression"
447 die "Unrecognized tarball compression";;
448 esac
449
450 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 920 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
921 unset z
451 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 922 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
452 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 923 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
453 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${STRICT_COUNT}/ 1>/dev/null 924 do z="${z}0";
925 done
926 PATCH_ORDER="${z}${STRICT_COUNT}"
927
928 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
929 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
930 unpack ${i##*/}
931 popd >/dev/null
454 else 932 else
455 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 933 pushd "${KPATCH_DIR}" >/dev/null
934 unpack ${i##*/}
935 popd >/dev/null
456 fi 936 fi
457 937
458 if [ $? == 0 ]; then
459 einfo "${i/*\//} unpacked"
460 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 938 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
461 else
462 eerror "Failed to unpack ${i/:*/}"
463 die "unable to unpack patch tarball"
464 fi
465 else 939 else
466 extention=${i/*./} 940 extention=${i/*./}
467 extention=${extention/:*/} 941 extention=${extention/:*/}
468 PIPE_CMD="" 942 PIPE_CMD=""
469 case ${extention} in 943 case ${extention} in
944 xz) PIPE_CMD="xz -dc";;
945 lzma) PIPE_CMD="lzma -dc";;
470 bz2) PIPE_CMD="bzip2 -dc";; 946 bz2) PIPE_CMD="bzip2 -dc";;
471 patch) PIPE_CMD="cat";; 947 patch) PIPE_CMD="cat";;
472 diff) PIPE_CMD="cat";; 948 diff) PIPE_CMD="cat";;
473 gz|Z|z) PIPE_CMD="gzip -dc";; 949 gz|Z|z) PIPE_CMD="gzip -dc";;
474 ZIP|zip) PIPE_CMD="unzip -p";; 950 ZIP|zip) PIPE_CMD="unzip -p";;
489 eerror "or does not exist." 965 eerror "or does not exist."
490 die Unable to locate ${i} 966 die Unable to locate ${i}
491 fi 967 fi
492 968
493 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 969 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
970 unset z
494 STRICT_COUNT=$((${STRICT_COUNT} + 1)) 971 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
972 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
973 do z="${z}0";
974 done
975 PATCH_ORDER="${z}${STRICT_COUNT}"
976
495 mkdir -p ${KPATCH_DIR}/${STRICT_COUNT}/ 977 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
496 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${STRICT_COUNT}/${x}.patch${PATCH_LEVEL}) 978 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
497 else 979 else
498 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) 980 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
499 fi 981 fi
500 fi 982 fi
501 fi 983 fi
502 done 984 done
503 985
505 x=${KPATCH_DIR} 987 x=${KPATCH_DIR}
506 KPATCH_DIR="" 988 KPATCH_DIR=""
507 for i in $(find ${x} -type d | sort -n); do 989 for i in $(find ${x} -type d | sort -n); do
508 KPATCH_DIR="${KPATCH_DIR} ${i}" 990 KPATCH_DIR="${KPATCH_DIR} ${i}"
509 done 991 done
992
993 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
994 # bug #272676
995 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
996 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
997 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
998 echo
999 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
1000 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
1001 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
1002 echo
1003 fi
1004 fi
510 1005
511 #so now lets get rid of the patchno's we want to exclude 1006 #so now lets get rid of the patchno's we want to exclude
512 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 1007 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
513 for i in ${UNIPATCH_DROP}; do 1008 for i in ${UNIPATCH_DROP}; do
514 ebegin "Excluding Patch #${i}" 1009 ebegin "Excluding Patch #${i}"
521 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do 1016 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
522 STDERR_T="${T}/${i/*\//}" 1017 STDERR_T="${T}/${i/*\//}"
523 STDERR_T="${STDERR_T/.patch*/.err}" 1018 STDERR_T="${STDERR_T/.patch*/.err}"
524 1019
525 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/} 1020 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
526 [ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/} 1021 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
527 1022
528 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 1023 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
529 1024
530 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 1025 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
531 while [ ${PATCH_DEPTH} -lt 5 ]; do 1026 while [ ${PATCH_DEPTH} -lt 5 ]; do
532 echo "Attempting Dry-run:" >> ${STDERR_T} 1027 echo "Attempting Dry-run:" >> ${STDERR_T}
533 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T} 1028 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
534 echo "=======================================================" >> ${STDERR_T} 1029 echo "=======================================================" >> ${STDERR_T}
535 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then 1030 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
536 echo "Attempting patch:" > ${STDERR_T} 1031 echo "Attempting patch:" > ${STDERR_T}
537 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T} 1032 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
538 echo "=======================================================" >> ${STDERR_T} 1033 echo "=======================================================" >> ${STDERR_T}
539 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 1034 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
540 eend 0 1035 eend 0
541 rm ${STDERR_T} 1036 rm ${STDERR_T}
542 break 1037 break
543 else 1038 else
544 eend 1 1039 eend 1
545 eerror "Failed to apply patch ${i/*\//}" 1040 eerror "Failed to apply patch ${i/*\//}"
546 eerror "Please attach ${STDERR_T} to any bug you may post." 1041 eerror "Please attach ${STDERR_T} to any bug you may post."
1042 eshopts_pop
547 die "Failed to apply ${i/*\//}" 1043 die "Failed to apply ${i/*\//}"
548 fi 1044 fi
549 else 1045 else
550 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 1046 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
551 fi 1047 fi
552 done 1048 done
553 if [ ${PATCH_DEPTH} -eq 5 ]; then 1049 if [ ${PATCH_DEPTH} -eq 5 ]; then
554 eend 1 1050 eend 1
555 eerror "Please attach ${STDERR_T} to any bug you may post." 1051 eerror "Please attach ${STDERR_T} to any bug you may post."
1052 eshopts_pop
556 die "Unable to dry-run patch." 1053 die "Unable to dry-run patch."
557 fi 1054 fi
558 done 1055 done
559 done 1056 done
560 1057
1058 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
1059 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
1060 # which is why I'm not taking too much time over this.
1061 local tmp
1062 for i in ${UNIPATCH_DOCS}; do
1063 tmp="${tmp} ${i//*\/}"
1064 cp -f ${i} "${T}"/
1065 done
1066 UNIPATCH_DOCS="${tmp}"
1067
561 # clean up KPATCH_DIR's - fixes bug #53610 1068 # clean up KPATCH_DIR's - fixes bug #53610
562 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 1069 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
563 1070
564 LC_ALL="${myLC_ALL}" 1071 LC_ALL="${myLC_ALL}"
1072 LANG="${myLANG}"
1073 eshopts_pop
565} 1074}
566 1075
567# getfilevar accepts 2 vars as follows: 1076# getfilevar accepts 2 vars as follows:
568# getfilevar <VARIABLE> <CONFIGFILE> 1077# getfilevar <VARIABLE> <CONFIGFILE>
569# pulled from linux-info 1078# pulled from linux-info
570 1079
571getfilevar() { 1080getfilevar() {
572 local workingdir basefname basedname xarch=$(tc-arch-kernel) 1081 local workingdir basefname basedname xarch=$(tc-arch-kernel)
573 1082
574 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then 1083 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
575 ebeep
576 echo -e "\n" 1084 echo -e "\n"
577 eerror "getfilevar requires 2 variables, with the second a valid file." 1085 eerror "getfilevar requires 2 variables, with the second a valid file."
578 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 1086 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
579 else 1087 else
580 workingdir=${PWD} 1088 workingdir=${PWD}
581 basefname=$(basename ${2}) 1089 basefname=$(basename ${2})
582 basedname=$(dirname ${2}) 1090 basedname=$(dirname ${2})
583 unset ARCH 1091 unset ARCH
584 1092
585 cd ${basedname} 1093 cd ${basedname}
586 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 1094 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
587 make ${BUILD_FIXES} -f - e 2>/dev/null 1095 make ${BUILD_FIXES} -s -f - e 2>/dev/null
588 cd ${workingdir} 1096 cd ${workingdir}
589 1097
590 ARCH=${xarch} 1098 ARCH=${xarch}
591 fi 1099 fi
592}
593
594detect_version() {
595 # this function will detect and set
596 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
597 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
598 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
599
600 if [[ -n ${KV_FULL} ]]; then
601 # we will set this for backwards compatibility.
602 KV=${KV_FULL}
603
604 # we know KV_FULL so lets stop here. but not without resetting S
605 S=${WORKDIR}/linux-${KV_FULL}
606 return
607 fi
608
609 # CKV is used as a comparison kernel version, which is used when
610 # PV doesnt reflect the genuine kernel version.
611 # this gets set to the portage style versioning. ie:
612 # CKV=2.6.11_rc4
613 CKV=${CKV:-${PV}}
614 OKV=${OKV:-${CKV}}
615 OKV=${OKV/_beta/-test}
616 OKV=${OKV/_rc/-rc}
617 OKV=${OKV/-r*}
618 OKV=${OKV/_p*}
619
620 KV_MAJOR=$(get_version_component_range 1 ${OKV})
621 KV_MINOR=$(get_version_component_range 2 ${OKV})
622 KV_PATCH=$(get_version_component_range 3- ${OKV})
623 KV_PATCH=${KV_PATCH/[-_]*}
624
625 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
626
627 RELEASE=${CKV/${OKV}}
628 RELEASE=${RELEASE/_beta}
629 RELEASE=${RELEASE/_rc/-rc}
630 RELEASE=${RELEASE/_pre/-pre}
631 kernel_is_2_6 && RELEASE=${RELEASE/-pre/-bk}
632 RELEASETYPE=${RELEASE//[0-9]}
633
634 # Now we know that RELEASE is the -rc/-bk
635 # and RELEASETYPE is the same but with its numerics stripped
636 # we can work on better sorting EXTRAVERSION.
637 # first of all, we add the release
638 EXTRAVERSION="${RELEASE}"
639
640 if [[ -n ${K_PREPATCHED} ]]; then
641 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
642 elif [[ "${ETYPE}" = "sources" ]]; then
643 # For some sources we want to use the PV in the extra version
644 # This is because upstream releases with a completely different
645 # versioning scheme.
646 case ${PN/-*} in
647 wolk) K_USEPV=1;;
648 vserver) K_USEPV=1;;
649 esac
650
651 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
652 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
653 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
654 fi
655
656 KV_FULL=${OKV}${EXTRAVERSION}
657
658 # -rc-bk pulls can be achieved by specifying CKV
659 # for example:
660 # CKV="2.6.11_rc3_pre2"
661 # will pull:
662 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-bk2.bz2
663
664 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
665 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
666 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2
667 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
668 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2"
669 fi
670
671 if [[ ${RELEASETYPE} == -bk ]]; then
672 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2
673 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
674 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2"
675 fi
676
677 if [[ ${RELEASETYPE} == -rc-bk ]]; then
678 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
679 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2
680 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2
681 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2"
682 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-bk*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2"
683 fi
684
685 # we will set this for backwards compatibility.
686 S=${WORKDIR}/linux-${KV_FULL}
687 KV=${KV_FULL}
688} 1100}
689 1101
690detect_arch() { 1102detect_arch() {
691 # This function sets ARCH_URI and ARCH_PATCH 1103 # This function sets ARCH_URI and ARCH_PATCH
692 # with the neccessary info for the arch sepecific compatibility 1104 # with the neccessary info for the arch sepecific compatibility
698 # ARCH_URI is the URI for all the ${ARCH}_URI patches 1110 # ARCH_URI is the URI for all the ${ARCH}_URI patches
699 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH 1111 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
700 1112
701 ARCH_URI="" 1113 ARCH_URI=""
702 ARCH_PATCH="" 1114 ARCH_PATCH=""
703 ALL_ARCH="X86 PPC PPC64 SPARC MIPS ALPHA ARM HPPA AMD64 IA64 X86OBSD S390 SH" 1115 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
704 1116
705 for LOOP_ARCH in ${ALL_ARCH}; do 1117 for LOOP_ARCH in ${ALL_ARCH}; do
706 COMPAT_URI="${LOOP_ARCH}_URI" 1118 COMPAT_URI="${LOOP_ARCH}_URI"
707 COMPAT_URI="${!COMPAT_URI}" 1119 COMPAT_URI="${!COMPAT_URI}"
708 1120
778 return 0 1190 return 0
779} 1191}
780 1192
781headers___fix() { 1193headers___fix() {
782 # Voodoo to partially fix broken upstream headers. 1194 # Voodoo to partially fix broken upstream headers.
783 # Issues with this function should go to plasmaroo. 1195 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
784 sed -i \ 1196 sed -i \
785 -e "s/\([ "$'\t'"]\)u8\([ "$'\t'"]\)/\1__u8\2/g;" \ 1197 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
786 -e "s/\([ "$'\t'"]\)u16\([ "$'\t'"]\)/\1__u16\2/g;" \
787 -e "s/\([ "$'\t'"]\)u32\([ "$'\t'"]\)/\1__u32\2/g;" \
788 -e "s/\([ "$'\t'"]\)u64\([ "$'\t'"]\)/\1__u64\2/g;" \
789 -e "s/\([ "$'\t'"]\)s64\([ "$'\t'"]\)/\1__s64\2/g;" \
790 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1198 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
791 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1199 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1200 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1201 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
792 "$@" 1202 "$@"
793} 1203}
794 1204
795# common functions 1205# common functions
796#============================================================== 1206#==============================================================
797kernel-2_src_unpack() { 1207kernel-2_src_unpack() {
798 universal_unpack 1208 universal_unpack
1209 debug-print "Doing unipatch"
799 1210
800 [[ -n ${UNIPATCH_LIST} ]] || [[ -n ${UNIPATCH_LIST_DEFAULT} ]] && \ 1211 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
801 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST}" 1212 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
802 1213
803 [ -z "${K_NOSETEXTRAVERSION}" ] && \ 1214 debug-print "Doing premake"
804 unpack_set_extraversion
805 1215
1216 # allow ebuilds to massage the source tree after patching but before
1217 # we run misc `make` functions below
1218 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1219
1220 debug-print "Doing epatch_user"
1221 epatch_user
1222
1223 debug-print "Doing unpack_set_extraversion"
1224
1225 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1226 unpack_fix_install_path
1227
1228 # Setup xmakeopts and cd into sourcetree.
1229 env_setup_xmakeopts
1230 cd "${S}"
1231
1232 # We dont need a version.h for anything other than headers
1233 # at least, I should hope we dont. If this causes problems
1234 # take out the if/fi block and inform me please.
1235 # unpack_2_6 should now be 2.6.17 safe anyways
1236 if [[ ${ETYPE} == headers ]]; then
806 kernel_is 2 4 && unpack_2_4 1237 kernel_is 2 4 && unpack_2_4
1238 kernel_is 2 6 && unpack_2_6
1239 fi
1240
1241 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1242 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1243 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1244 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1245 fi
807} 1246}
808 1247
809kernel-2_src_compile() { 1248kernel-2_src_compile() {
810 cd ${S} 1249 cd "${S}"
811 [[ ${ETYPE} == headers ]] && compile_headers 1250 [[ ${ETYPE} == headers ]] && compile_headers
812 [[ ${ETYPE} == sources ]] && \ 1251
813 use doc && ! use arm && ! use s390 && compile_manpages 1252 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1253 echo ">>> Running deblob script ..."
1254 sh "${T}/${DEBLOB_A}" --force || \
1255 die "Deblob script failed to run!!!"
1256 fi
814} 1257}
1258
1259# if you leave it to the default src_test, it will run make to
1260# find whether test/check targets are present; since "make test"
1261# actually produces a few support files, they are installed even
1262# though the package is binchecks-restricted.
1263#
1264# Avoid this altogether by making the function moot.
1265kernel-2_src_test() { :; }
815 1266
816kernel-2_pkg_preinst() { 1267kernel-2_pkg_preinst() {
817 [[ ${ETYPE} == headers ]] && preinst_headers 1268 [[ ${ETYPE} == headers ]] && preinst_headers
818} 1269}
819 1270
822 [[ ${ETYPE} == headers ]] && install_headers 1273 [[ ${ETYPE} == headers ]] && install_headers
823 [[ ${ETYPE} == sources ]] && install_sources 1274 [[ ${ETYPE} == sources ]] && install_sources
824} 1275}
825 1276
826kernel-2_pkg_postinst() { 1277kernel-2_pkg_postinst() {
827 [[ ${ETYPE} == headers ]] && postinst_headers
828 [[ ${ETYPE} == sources ]] && postinst_sources 1278 [[ ${ETYPE} == sources ]] && postinst_sources
829} 1279}
830 1280
831kernel-2_pkg_setup() { 1281kernel-2_pkg_setup() {
1282 if kernel_is 2 4; then
1283 if [ "$( gcc-major-version )" -eq "4" ] ; then
1284 echo
1285 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1286 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1287 ewarn "newer kernel that supports gcc-4."
1288 echo
1289 ewarn "Also be aware that bugreports about gcc-4 not working"
1290 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1291 echo
1292 epause 10
1293 fi
1294 fi
1295
1296 ABI="${KERNEL_ABI}"
832 [[ ${ETYPE} == headers ]] && setup_headers 1297 [[ ${ETYPE} == headers ]] && setup_headers
833 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1298 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
834} 1299}
1300
1301kernel-2_pkg_postrm() {
1302 echo
1303 ewarn "Note: Even though you have successfully unmerged "
1304 ewarn "your kernel package, directories in kernel source location: "
1305 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1306 ewarn "with modified files will remain behind. By design, package managers"
1307 ewarn "will not remove these modified files and the directories they reside in."
1308 echo
1309}
1310

Legend:
Removed from v.1.100  
changed lines
  Added in v.1.260

  ViewVC Help
Powered by ViewVC 1.1.20